

   /* Default specification of the fourbar-slider linkage. */
   r[1] = r1;  r[2] = r2;  r[3] = r3;
   r[4] = r4;  r[5] = r5;  r[6] = r6;
   for(i = 1; i <= 4; i++)
   {
      theta[i][1] = M_DEG2RAD(theta1);
      theta[i][2] = M_DEG2RAD(theta2);
      omega[i][2] = M_DEG2RAD(omega2);	// rad/sec 
   }
   psi = M_DEG2RAD(psi);
   
   /* Perform fourbar-slider linkage analysis. */
   fslider.setLinks(r, theta[1][1], psi); 
   fslider.angularPos(theta[1], theta[2], theta[3], theta[4]);
   fslider.angularVel(theta[1], omega[1]);
   fslider.angularVel(theta[2], omega[2]);
   fslider.angularVel(theta[3], omega[3]);
   fslider.angularVel(theta[4], omega[4]);
   
   for(i = 1; i <= 6; i++)
   {
	  omega_deg1[i] = M_RAD2DEG(omega[1][i]);
	  omega_deg2[i] = M_RAD2DEG(omega[2][i]);
	  omega_deg3[i] = M_RAD2DEG(omega[3][i]);
	  omega_deg4[i] = M_RAD2DEG(omega[4][i]);
	  omega_rad1[i] = omega[1][i];
	  omega_rad2[i] = omega[2][i];
	  omega_rad3[i] = omega[3][i];
	  omega_rad4[i] = omega[4][i];
	}
