/* Copyright (c) 2001-2004 by SoftIntegration, Inc. All Rights Reserved */
#include<stdio.h>
#include<sixbar.h>

int main()
{
   double r[1:6];
   double rP3, beta3,
          rPP4, beta4,
          rP5, beta5;
   double theta[1:4][1:6];
   double theta1 = M_DEG2RAD(10), theta2 = M_DEG2RAD(25);
   CWattSixbarI wattI;
   int i;

   /* Define Watt (I) Sixbar linkage. */
   r[1] = 8;  r[2] = 4;
   r[3] = 10;  r[4] = 7;
   r[5] = 7;   r[6] = 8;
   rP3 = 4;  beta3 = M_DEG2RAD(30);
   rPP4 = 9;  beta4 = M_DEG2RAD(50);
   rP5 = 4;  beta5 = M_DEG2RAD(35);
   for(i = 1; i <= 4; i++)
   {
      theta[i][1] = theta1;
      theta[i][2] = theta2;
   }

   /* Perform analysis. */
   wattI.setLinks(r, theta1, rP3, beta3, rPP4, beta4); 
   wattI.setCouplerPoint(COUPLER_LINK5, rP5, beta5);
   wattI.angularPos(theta[1], theta[2], theta[3], theta[4]);
   wattI.displayPosition(theta[1][2], theta[1][3], theta[1][4], theta[1][5], theta[1][6]);  

   return 0;
}
