/* Copyright (c) 2001-2004 by SoftIntegration, Inc. All Rights Reserved */
/*************************************************
 *  This example is for calculating the angular  *
 *  position of various links of a               *
 *  Watt (II) sixbar linkage.                    *
 *************************************************/

#include <sixbar.h>

int main() {
  CWattSixbarII wattbar;
  double r[1:8];
  double theta1 = 10*M_PI/180;
  double theta5 = 350*M_PI/180;
  double rp = 5, beta = 45*M_PI/180;
  double psi = 30*M_PI/180;
  double theta_1[1:8], theta_2[1:8], theta_3[1:8], theta_4[1:8];
  double omega_1[1:8], omega_2[1:8], omega_3[1:8], omega_4[1:8];
  double alpha_1[1:8], alpha_2[1:8], alpha_3[1:8], alpha_4[1:8];
  double theta2 = 70*M_PI/180;
  double complex p[1:4]; // two solution of coupler point position
  int i;
  double complex vp1, vp2, vp3, vp4;
  double complex ap1, ap2, ap3, ap4;
  
  r[1] = 12, r[2] = 4, r[3] = 12.0, r[4] = 7.0;
  r[5] = 7,  r[6] = 5.0, r[7] = 8.0, r[8] = 6.0;
  theta_1[1] = theta1;
  theta_1[2] = theta2; // theta2

  wattbar.setLinks(r, theta1, theta5, psi);
  wattbar.angularPos(theta_1, theta_2, theta_3, theta_4);
  
  /**** print solutions ****/
  printf("\n Circuit 1: Angular Position\n\n");
  for(i=2; i<=8;i++) 
    if(i!=5)
      printf("theta%d = %6.3f\n", i, theta_1[i]);
  printf("\n Circuit 2: Angular Position\n\n");
  for(i=2; i<=8;i++)
    if(i!=5)
      printf("theta%d = %6.3f\n", i, theta_2[i]);
  printf("\n Circuit 3: Angular Position\n\n");
  for(i=2; i<=8;i++) 
    if(i!=5)
      printf("theta%d = %6.3f\n", i, theta_3[i]);
  printf("\n Circuit 4: Angular Position\n\n");
  for(i=2; i<=8;i++)
    if(i!=5)
      printf("theta%d = %6.3f\n", i, theta_4[i]);

  return 0;
}
  
