/* Copyright (c) 2001-2004 by SoftIntegration, Inc. All Rights Reserved */
/**************************************************
 *  This example is for displaying the position   *
 *  of the Watt (II) sixbar linkage.              *
 **************************************************/

#include </usr/ch/toolkit/include/sixbar.h>

int main() {
  CWattSixbarII wattbar; 
  double r[1:8];
  double theta1 = 10*M_PI/180;
  double theta5 = -10*M_PI/180;
  double rp = 5, beta = 45*M_PI/180;
  double psi = 30*M_PI/180;
  double theta_1[1:8], theta_2[1:8], theta_3[1:8], theta_4[1:8];
  double theta2 = 70*M_PI/180;
  double complex p[1:4]; // four solution of coupler point position
  int i;
  double complex vp[1:4];
  double complex ap[1:4];

  r[1] = 12, r[2] = 4, r[3] = 12, r[4] = 7;
  r[5] = 7,  r[6] = 5, r[7] = 8, r[8] = 6;

  theta_1[1] = theta1;
  theta_1[2] = theta2; // theta2

  wattbar.uscUnit(1);
  wattbar.setLinks(r, theta1, theta5, psi);
  wattbar.setCouplerPoint(COUPLER_LINK7, rp, beta);
  wattbar.angularPos(theta_1, theta_2, theta_3, theta_4);
  wattbar.displayPosition(theta_1[2], theta_1[3], theta_1[4], theta_1[7], theta_1[8]);  

  return 0;
}
