/* Copyright (c) 2001-2004 by SoftIntegration, Inc. All Rights Reserved */
#include <sixbar.h>

int main() {
  CWattSixbarII wattbar;
  double r[1:8];
  double theta1 = 10*M_PI/180;
  double theta5 = -10*M_PI/180;
  double rp = 5, beta = 45*M_PI/180;
  double psi = 30*M_PI/180;
  double theta_1[1:8], theta_2[1:8], theta_3[1:8], theta_4[1:8];
  double omega_1[1:8], omega_2[1:8], omega_3[1:8], omega_4[1:8];
  double alpha_1[1:8], alpha_2[1:8], alpha_3[1:8], alpha_4[1:8];
  double theta2 = 70*M_PI/180;
  double complex P[1:4]; // four solution of coupler point position
  int i;
  double complex Vp[1:4];
  double complex Ap[1:4];

  r[1] = 12, r[2] = 4, r[3] = 12.0, r[4] = 7.0;
  r[5] = 7,  r[6] = 5.0, r[7] = 8.0, r[8] = 6.0;
  omega_1[2]=10*M_PI/180;  /*  rad/sec  */
  alpha_1[2]=0;  /*  rad/sec*sec  */

  theta_1[1] = theta1;
  theta_1[2] = theta2; // theta2
  omega_2[2] = omega_3[2] = omega_4[2] = omega_1[2];
  alpha_2[2] = alpha_3[2] = alpha_4[2] = alpha_1[2];

  wattbar.setLinks(r, theta1, theta5, psi);
  wattbar.setCouplerPoint(SIXBAR_LINK7, rp, beta);

  wattbar.angularPos(theta_1, theta_2, theta_3, theta_4);
  wattbar.couplerPointPos(SIXBAR_LINK7, theta_1[2], P);

  /* first solution */
  wattbar.angularVel(theta_1, omega_1);
  wattbar.angularAccel(theta_1, omega_1, alpha_1);
  Vp[1] = wattbar.couplerPointVel(SIXBAR_LINK7, theta_1, omega_1); 
  Ap[1] = wattbar.couplerPointAccel(SIXBAR_LINK7, theta_1, omega_1, alpha_1);  

  /* second solution */
  wattbar.angularVel(theta_2, omega_2);
  wattbar.angularAccel(theta_2, omega_2, alpha_2);
  Vp[2] = wattbar.couplerPointVel(SIXBAR_LINK7, theta_2, omega_2); 
  Ap[2] = wattbar.couplerPointAccel(SIXBAR_LINK7, theta_2, omega_2, alpha_2);  

  /* third solution */
  wattbar.angularVel(theta_3, omega_3);
  wattbar.angularAccel(theta_3, omega_3, alpha_3);
  Vp[3] = wattbar.couplerPointVel(SIXBAR_LINK7, theta_3, omega_3); 
  Ap[3] = wattbar.couplerPointAccel(SIXBAR_LINK7, theta_3, omega_3, alpha_3);  

  /* fouth solution */
  wattbar.angularVel(theta_4, omega_4);
  wattbar.angularAccel(theta_4, omega_4, alpha_4);
  Vp[4] = wattbar.couplerPointVel(SIXBAR_LINK7, theta_4, omega_4); 
  Ap[4] = wattbar.couplerPointAccel(SIXBAR_LINK7, theta_4, omega_4, alpha_4);  

  /* Display the results. */
  for (i=1; i<=4; i++) {
    printf("P[%d] = %6.3f + i%6.3f \n", i, real(P[i]), imag(P[i]));
    printf("Vp[%d] = %6.3f + i%6.3f \n", i, real(Vp[i]), imag(Vp[i]));
    printf("Ap[%d] = %6.3f + i%6.3f \n", i, real(Ap[i]), imag(Ap[i]));
  }

  return 0;
}
